<template>
  <button @click="generatePDF">Exporter en PDF</button>
</template>
<script setup lang="ts">
import jsPDF from "jspdf";
const etudiant = {
 cours: "420-14D-FX",
 nom: "Doe",
 prenom: "John",
 epreuve: "TP1",
 dateDeCorrection: "2021-10-10",
 elemts: [
    {
      nom: "Qualité du code source",
      note: 10,
      ponderation: 10,
      critere: "Code propre, bien commenté, et facile à comprendre",
      bareme: {
        excellent: {
          title: "Excellent",
          texte: "Très bien, vous avez obtenu la note maximale pour cet élément.",
          note: 10,
          selected: true,
        },
        tresBien: {
          title: "Très bien",
          texte: "Bien, vous avez obtenu une note supérieure à la moyenne pour cet élément.",
          note: 8,
          selected: false,
        },
        bien: {
          title: "Bien",
          texte: "Vous avez obtenu une note moyenne pour cet élément.",
          note: 6,
          selected: false,
        },
        passable: {
          title: "Passable",
          texte: "Vous avez obtenu une note inférieure à la moyenne pour cet élément.",
          note: 4,
          selected: false,
        },
      },
      commentaire: "Très bien! Continuez comme ça.",
    },
    {
      nom: "Intégration de la base de données dans le code",
      note: 17,
      ponderation: 20,
      critere: "Utilisation efficace des requêtes SQL et gestion des erreurs",
      bareme: {
        excellent: {
          title: "Excellent",
          texte: "Très bien, vous avez obtenu la note maximale pour cet élément.",
          note: 10,
          selected: false,
        },
        tresBien: {
          title: "Très bien",
          texte: "Bien, vous avez obtenu une note supérieure à la moyenne pour cet élément.",
          note: 8,
          selected: true,
        },
        bien: {
          title: "Bien",
          texte: "Vous avez obtenu une note moyenne pour cet élément.",
          note: 6,
          selected: false,
        },
        passable: {
          title: "Passable",
          texte: "Vous avez obtenu une note inférieure à la moyenne pour cet élément.",
          note: 4,
          selected: false,
        },
      },
      commentaire: "Bien! Continuez comme ça.",
    },
    {
      nom: "Utilisation des fonctions de sécurité de l'API",
      note: 22,
      ponderation: 30,
      critere: "Implémentation de mécanismes d'authentification et de validation des données",
      bareme: {
        excellent: {
          title: "Excellent",
          texte: "Très bien, vous avez obtenu la note maximale pour cet élément.",
          note: 10,
          selected: false,
        },
        tresBien: {
          title: "Très bien",
          texte: "Bien, vous avez obtenu une note supérieure à la moyenne pour cet élément.",
          note: 8,
          selected: false,
        },
        bien: {
          title: "Bien",
          texte: "Vous avez obtenu une note moyenne pour cet élément.",
          note: 6,
          selected: true,
        },
        passable: {
          title: "Passable",
          texte: "Vous avez obtenu une note inférieure à la moyenne pour cet élément.",
          note: 4,
          selected: false,
        },
      },
      commentaire: "Bon travail, continuez ainsi.",
    },
    {
      nom: "Design de l'interface utilisateur",
      note: 35,
      ponderation: 40,
      critere: "Interface intuitive et esthétiquement agréable",
      bareme: {
        excellent: {
          title: "Excellent",
          texte: "Très bien, vous avez obtenu la note maximale pour cet élément.",
          note: 10,
          selected: false,
        },
        tresBien: {
          title: "Très bien",
          texte: "Bien, vous avez obtenu une note supérieure à la moyenne pour cet élément.",
          note: 8,
          selected: true,
        },
        bien: {
          title: "Bien",
          texte: "Vous avez obtenu une note moyenne pour cet élément.",
          note: 6,
          selected: false,
        },
        passable: {
          title: "Passable",
          texte: "Vous avez obtenu une note inférieure à la moyenne pour cet élément.",
          note: 4,
          selected: false,
        },
      },
      commentaire: "Très bien! Continuez comme ça.",
    },
 ],
 noteFinale: 100,
};


function generatePDF() {
  const doc = new jsPDF();
  const pageWidth = doc.internal.pageSize.getWidth();
  const margin = 10;
  const elementFontSize = 15;
  const cardWidth = 180;
  const cardHeight = 0;
  const cardSpacing = 10;
  const lineHeight = 10;
  let noteFinaleEtudiant = 0;

  let currentPage = 1;
  let yPosition = margin;

  function addElement(element : any) {
    const elementText = `${element.nom}`;
    const critereText = `Critère : ${element.critere}`;
    let notePonderationText = `${element.note} / ${element.ponderation}`;
    noteFinaleEtudiant += element.note;

    // Ajouter le texte de l'élément
    doc.setFont("helvetica", "bold");
    doc.setFontSize(elementFontSize);
    doc.text(elementText, margin, yPosition);
    doc.setFont("helvetica", "normal");
    doc.text(
      notePonderationText,
      pageWidth -
        margin -
        (doc.getStringUnitWidth(notePonderationText) * elementFontSize) /
          doc.internal.scaleFactor,
      yPosition
    );

    // Ajouter le critère de l'élément juste après le nom et la note/ponderation
    yPosition += lineHeight;
    doc.setFontSize(12);
    doc.text(critereText, margin, yPosition);

    yPosition += lineHeight;

    // Ajouter les baremes de l'élément dans des cadres à côté les uns des autres
    let xPosition = margin;
    Object.values(element.bareme).forEach((bareme : any) => {
      const baremeText = `${bareme.title}: ${bareme.texte}`;
      doc.setDrawColor(0);
      doc.setFillColor(255, 255, 255);
      doc.rect(xPosition, yPosition - 5, cardWidth, cardHeight, "F");
      doc.setTextColor(bareme.selected ? "blue" : "black");
      doc.setFontSize(10);
      doc.text(baremeText, xPosition + 5, yPosition);

      xPosition += cardWidth + cardSpacing;
      if (xPosition + cardWidth > pageWidth - margin) {
        xPosition = margin;
        yPosition += cardHeight + cardSpacing;
      }
    });

    // Ajouter le commentaire pour l'élément
    doc.setFont("helvetica", "bold");
    doc.setFontSize(12);
    doc.text(`Commentaires : ${element.commentaire}`, margin + 5, yPosition);

    yPosition += lineHeight;

    yPosition += cardHeight + cardSpacing;
}

  function addNewPageIfNeeded() {
    const elementHeight = lineHeight * 3;
    const spaceLeft = doc.internal.pageSize.getHeight() - yPosition;

    if (spaceLeft < elementHeight) {
      doc.addPage();
      yPosition = margin;
      currentPage++;
    }
  }

  // Ajouter le titre et les informations de base
  doc.setFontSize(18);
  doc.text(`Grille de correction de ${etudiant.epreuve}`, margin, margin);
  doc.setFontSize(12);
  doc.text(`Cours : ${etudiant.cours}`, margin, margin + 20);
  doc.text(
    `Nom de l'étudiant : ${etudiant.prenom} ${etudiant.nom}`,
    margin,
    margin + 30
  );
  doc.text(
    `Date de correction : ${etudiant.dateDeCorrection}`,
    margin,
    margin + 40
  );
  yPosition += 50;

  // Ajouter les éléments
  etudiant.elemts.forEach((element) => {
    addNewPageIfNeeded();
    addElement(element);
  });
  doc.setFont("helvetica", "bold");
  doc.setFontSize(14);
  doc.text(
    `Note finale : ${noteFinaleEtudiant} / ${etudiant.noteFinale}`,
    margin,
    yPosition
  );
  doc.save("etudiant.pdf");
}
</script>
